------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 3769 $ $Date: 2010-10-24 03:16:28 +0400 (Sun, 24 Oct 2010) $
------------------------------------------------------------------------------

package body Qt4.Paint_Devices.Impl is

   function paintEngine_dispatch
    (Self : not null access Q_Paint_Device_Impl'Class)
       return not null access Qt4.Paint_Engines.Q_Paint_Engine;
   pragma Export
    (C, paintEngine_dispatch, "__Qt4Ada_QPaintDevice_paintEngine_dispatch");
   pragma Warnings (Off, paintEngine_dispatch);

   function metric_dispatch
    (Self   : not null access constant Qt4_Entities.Limited_Entity'Class;
     Metric : Paint_Device_Metric)
       return Q_Integer;
   pragma Export
    (C, metric_dispatch, "__Qt4Ada_QPaintDevice_metric_0_dispatch");
   pragma Warnings (Off, metric_dispatch);

   ------------
   -- Metric --
   ------------

--   function Metric
--    (Self   : not null access constant Q_Paint_Device_Impl;
--     Metric : Paint_Device_Metric)
--       return Q_Integer
--   is
--   begin
--      if Self.Is_Director then
--         return
--           Thin.metric
--            (Q_Paint_Device_Impl'Class (Self.all).QPaintDevice_View, Metric);
--
--      else
--         raise Program_Error;
--      end if;
--   end Metric;

   ---------------------
   -- metric_dispatch --
   ---------------------

   function metric_dispatch
    (Self   : not null access constant Qt4_Entities.Limited_Entity'Class;
     Metric : Paint_Device_Metric)
       return Q_Integer
   is
   begin
      raise Program_Error;
      return 0;
--      return Q_Paint_Device_Impl_Base'Class (Self.all).Metric (Metric);
   end metric_dispatch;

   ------------------
   -- Paint_Engine --
   ------------------

   overriding function Paint_Engine
    (Self : not null access Q_Paint_Device_Impl)
       return not null access Qt4.Paint_Engines.Q_Paint_Engine
   is
   begin
      if Self.Is_Director then
         --  Pure virtual function can't be called.
         raise Program_Error;

      else
         return
           Thin.paintEngine_virtual
            (Q_Paint_Device_Impl'Class (Self.all).QPaintDevice_View);
      end if;
   end Paint_Engine;

   --------------------------
   -- paintEngine_dispatch --
   --------------------------

   function paintEngine_dispatch
    (Self : not null access Q_Paint_Device_Impl'Class)
       return not null access Qt4.Paint_Engines.Q_Paint_Engine
   is
   begin
      return Self.Paint_Engine;
   end paintEngine_dispatch;

end Qt4.Paint_Devices.Impl;
